// Frenchpress
module.exports = function Frenchpress (props) {
    
    var props = props || {};
    
    var options = {
        'articles'    : props['articles'] || 'articles',
        'port'        : props['port'] || 7000,
        'views'       : props['views'] || 'views',
        'view-engine' : props['view-engine'] || 'ejs',
        'meta'        : props['meta'] || [
            'title',
            'author',
            'date'
        ]
    };
    
    console.log("Boiling water...");
    
    var express = require('express'),
        fs      = require('fs'),
        props   = require('props'),
        md      = require('node-markdown').Markdown;
        
    var app = express.createServer();
    
    console.log("Grinding coffee...");
    
    // Set our views path (typically optional in express)
    app.set('views', __dirname + '/../' + options['views']);
    app.set('view engine', options['view-engine']);
    
    // Routes
    app.get('/', function(req, res){
        res.render('index');
    });
    
    app.get('/:name', function(req, res){
        
        var data = {};
        
        fs.readFile('./articles/' + req.params.name + '.press', function (err, fileContents) {
            
            if (err) { console.log(err) }
            
            fileContents = fileContents.toString();
            
            data = (props(fileContents));
                    
            data['content'] = md(data['__content']);
            
            res.render('article', data);
        });
        
    });
    
    this.brew = function() {
        app.listen(options['port']);
        console.log("Frenchpress is brewing on port " + options['port']);
    }
}